=== debian/changelog ===
rdkit (201903.1-2) unstable; urgency=medium

  * Team upload.

  [ Daniel Leidert ]
  * Add CI support
  * Use salsa-ci.yml as CI config and fix gbp.conf
  * Trigger rebuild

  [ Andrius Merkys ]
  * Removing build-dependency on no longer existing texlive-generic-extra
    (Closes: #933210)

 -- Andrius Merkys <merkys@debian.org>  Tue, 20 Aug 2019 01:11:38 -0400

rdkit (201903.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright: Removed Files-Excluded, no longer needed. 
  * debian/patches/NoDownloads.patch: Remove CoordGen-specific hunks and add
    another CoordGen-specific hunk that drops the template.mae template
    support.
  * debian/patches/sphinx_imgconverter.patch: Updated.
  * debian/patches/postgres_v11_support.patch: Removed, no longer needed.
  * debian/patches/testcase_32bit_fix.patch: Likewise.
  * debian/patches/fix_coordgen_include_path.patch: Likewise.
  * debian/control.in (Build-Depends): Added libboost-iostreams-dev.
  * debian/control.in (Build-Depends): Added versioned Depends on version 1.1-4
    of libschroedinger-coordgenlibs-dev.
  * debian/control.in (python-rdkit): Package removed.
  * debian/control.in (Build-Depends): Removed python-dev, python-numpy,
    python-pandas and python-pil.
  * debian/rules: Removed python(2) support.
  * debian/control.in (Build-Depends): Added versioned Depends on version 1.2-1
    of libschroedinger-maeparser-dev.
  * debian/control: Regenerated.
  * debian/rules (override_dh_install): Remove pycache directory before
    install.

 -- Michael Banck <mbanck@debian.org>  Tue, 23 Jul 2019 12:27:30 -0300

rdkit (201809.1+dfsg-7) unstable; urgency=medium

  * Team upload.

  [ Alexandre Mestiashvili ]
  * Update d/control.in, add python3-rdkit package and python3 build-deps
    (Closes: #919161)
  * Update d/rules, enable hardening, build python2 and python3 bindings
  * Remove debian/python-rdkit.install, install modules via d/rules
  * Update d/control with pg_buildext updatecontrol

 -- Andrius Merkys <merkys@debian.org>  Wed, 01 May 2019 07:56:24 -0400
